=== debian/control ===
Source: sather
Section: devel
Priority: optional
Maintainer: Norbert Nemec <nobbi@gnu.org>
Standards-Version: 2.4.0.0

Package: sather
Architecture: any
Depends: sather-common, libgc-dev, ${shlibs:Depends}
Suggests: tk8.0-dev
Provides: sacomp
Description: GNU Sather compiler and library
 Compiler and programming environment for Sather:
 Sather is an object oriented language which designed to be simple,
 efficient, safe, and non-proprietary. It aims to meet the needs of
 modern research groups and to foster the development of a large,
 freely available, high-quality library of efficient well-written
 classes for a wide variety of computational tasks. It was originally
 based on Eiffel but now incorporates ideas and approaches from several
 languages. One way of placing it in the "space of languages" is to say
 that it attempts to be as efficient as C, C++, or Fortran, as elegant
 and safe as Eiffel or CLU, and to support higher-order functions as
 well as Common Lisp, Scheme, or Smalltalk.

Package: sather-boot
Architecture: any
Depends: sather-common, libgc-dev, ${shlibs:Depends}
Suggests: tk8.0-dev
Provides: sacomp
Description: Old Sather compiler and library
 This is the Sather compiler using the old (pre-Waikato) library. It is 
 provided for compiling old code (and because the new library has not 
 yet reached much stability)

Package: sather-common
Architecture: all
Depends: sacomp, ${shlibs:Depends}
Description: Common files for both Sather versions

Package: sather-par
Architecture: any
Depends: sather
Description: pSather - Parallel extensions to the Sather environment
 There are two implementations included in this package:
 One based upon LWP, a implementation of user-space threads, which is also
 included in this package.
 The other based upon ActiveThreads LWP, a implementation based upon POSIX 
 threads, which is also included in this package.

Package: sather-doc
Architecture: all
Suggests: sather, www-browser, postscript-viewer, info-browser
Description: Documentation for the object oriented language Sather
 HTML, PostScript, Info documentation for the object oriented language
 Sather.

Package: sather-elisp
Architecture: all
Depends: emacsen
Suggests: sather
Description: Emacs mode for editing Sather programs
 Emacs mode for editing Sather programs.

Package: sather-browser
Architecture: any
Depends: sather, c-shell, tclsh, ${shlibs:Depends}
Description: A Tcl/Tk based class browser for Sather.
 A class browser for the OO-language Sather, written in Sather, using the 
 Tcl/Tk toolkit.
